;Liste pour le Type et le Sens de dplacement 
Enumeration 
  #Nord
  #Est
  #Sud
  #Ouest
  #Vertical ; Vertical pour le type ou Arrt pour le sens de dplacement
  #Tombe
EndEnumeration

;Liste des polices
Enumeration 
  #Comic
  #ComicBig
EndEnumeration

#Taille=12             ;Taille d'un bloc
#Taille2 = #Taille/2
#Focale=50

Structure f_Vecteur
  x.f
  y.f
  z.f
EndStructure

Structure i_Vecteur
  x.l
  y.l
  z.l
EndStructure

Structure s_Map
  Level.l           ;Niveau en cours
  SizeX.l           ;Taille en X de la map 
  SizeZ.l           ;Taille en Z de la map
  SoundToggle.l     ;Pour ne pas rejouer le son si le joueur reste sur une dalle
  Vitesse.f
  Move.l            ;Compteur dplacement totalisateur
  MoveTmp.l         ;Compteur dplacement de la map en cours
  ;Complment pour l'diteur
  Type.l            ; Type du bloc slectionn pour l'diteur 
  Etat.l            ; Etat du bloc slectionn pour l'diteur
  Bloc.i_Vecteur    ; Bloc en cours pour l'diteur
  SBloc.i_Vecteur   ; Bloc slectionn pour l'diteur
  SSwitch.i_Vecteur ; Switch slectionn pour l'diteur 
EndStructure

Structure s_Player
  ;Rectangle ou 1er Cube
  Mesh.l    
  Entity.l
  Origine.I_Vecteur  
  p.f_Vecteur  ; position en cours
  s.f_Vecteur  ; Scale Mesh
  t.f_Vecteur  ; Translate Mesh 
  Type.l       ;
  Sens.l       ; Sens de dplacement 
  Out.l        ; Le joueur est sorti de la map
  Angle.f      ; Angle de rotation
  Vitesse.f    ; Vitesse dplacement du joueur
  Taille.l     ; Rectangle ou cubes 
  Bloc1.I_Vecteur ; Position sur la map
  Toggle1.l
  ;Deuxime Cube
  Entity2.l       ;No de l'entity du 2me cube
  Toggle2.l       ; Pour actionner une fois un interrupteur
  p2.f_Vecteur    ; Position du 2me cube
  Bloc2.I_Vecteur ; Position sur la map du 2me cube
EndStructure

Structure Screen
  Width.l
  Height.l
  Depth.l
  Width_2.l
  Height_2.l
  d.f
EndStructure


LoadFont(#Comic, "Comic", 24)
AddFontResource_("Fonts\Carolingia.ttf")
LoadFont(#ComicBig, "Carolingia", 128,#PB_Font_Bold )
;RemoveFontResource_("Carolingia.ttf")

Global Screen.Screen
Global CoefSelonFPS.f

Macro AFFICHE_INFORMATIONS(Level,Move,MoveTmp)
  If StartDrawing(ScreenOutput())
    DrawingFont(FontID(#Comic))
    DrawingMode(#PB_2DDrawing_Transparent)
    DrawText(10,10,"PassCode : " + PassCode(Level),$FFFFEE)
    DrawText(10,50,"Move        : " + Str(Move)+" / " + Str(MoveTmp),$FFFFEE)
    DrawText(Screen\Width-180,10, "FPS : " + Str(Engine3DFrameRate(#PB_Engine3D_Current)),$FFFFEE)
    StopDrawing()
  EndIf 
EndMacro


;Ecran
If ExamineDesktops()
  Screen\Width = DesktopWidth(0)
  Screen\Height = DesktopHeight(0)
  Screen\Depth=DesktopDepth(0)
  Screen\Width_2 = Screen\Width  / 2
  Screen\Height_2 = Screen\Height / 2
  ;Calcul de l'angle pour les projections
  Screen\d = (Screen\Height / (2 * Tan((#Focale * 0.0174533) / 2.0)))
EndIf

Declare Main()
Declare InitGame()
Declare MessageErreur(Texte.s)
Declare Preferences(*Map.s_Map, *Player.s_Player)




; IDE Options = PureBasic 4.10 Beta 3 (Windows - x86)
; CursorPosition = 107
; FirstLine = 70
; Folding = --