XIncludeFile "3D.pbi"

Structure s_Block
  Type.l           ;Type de bloc
  Entity.l         ;No de l'entity
  Etat.l           ;Etat du bloc (open, close ou autres)
  Random.f_Vecteur ; Utiliser pour grer des effets (perdu, construction de la map...) 
  Sens.l           ;Sens dplacement des nnuphars
  ;Wait.l           ;Temporise un dplacement
  Angle.f    
  c.f            
EndStructure

Macro AFFICHE_STAGE()
  StartDrawing(ScreenOutput())
    DrawingMode(#PB_2DDrawing_Transparent)
    DrawingFont(FontID(#ComicBig))
    Texte = "STAGE " + RSet(Str(*Map\Level),3,"0")
    DrawText(((Screen\Width-TextWidth(Texte))/2)+3,((Screen\height-TextHeight(Texte))/2)+3,Texte,$B6F2B0)
    DrawText((Screen\Width-TextWidth(Texte))/2,(Screen\height-TextHeight(Texte))/2,Texte,$325717)
  StopDrawing()
EndMacro

#MaxMapX = 15
#MaxMapZ = 10

Global Dim DataMap.s_Block(#MaxMapX,#MaxMapZ)   ;Donnes de la map en cours 
Global Dim FXMap.f_Vecteur(#MaxMapX,#MaxMapZ)   ;Pour crer des effets 

;-Declare
Declare InitMap(*Map.s_Map, *Player.s_Player)
Declare LoadMap(*Map.s_Map, *Player.s_Player)
Declare CreateMap(*Map.s_Map, *Player.s_Player)
Declare DisplayMap(*Map.s_Map, *Player.s_Player)
;Pour l'diteur
Declare InitBloc(*Map.s_Map)
Declare AddBloc(*Map.s_Map, *Player.s_Player,i,j)
Declare InitPlayer(*Player.s_Player)

; IDE Options = PureBasic 4.10 Beta 3 (Windows - x86)
; CursorPosition = 2
; Folding = -