XIncludeFile "main.pbi"

#Epsilon = 0.0001

Structure s_Rayon
	Origine.f_Vecteur              ;Origine du rayon
	Direction.f_Vecteur            ;Vecteur directeur du rayon
	;Informations collisions
 	CollisionDetectee.l             
 	DistanceLaPlusCourte.f
 	PointIntersection.f_Vecteur	   
EndStructure	

Structure s_Souris
  Clic.l
  Pos2D.POINT
  Pos3D.f_Vecteur
  Rayon.s_Rayon
 EndStructure
 
 Structure s_Plan
	Constante.f
 	Origine.f_Vecteur
 	Normale.f_Vecteur
EndStructure

Macro COPIE_VECTEUR(V, V1)
  V\x = V1\x
  V\y = V1\y
  V\z = V1\z
EndMacro 

 Macro NORME(V)
  (Sqr(V\x * V\x + V\y * V\y + V\z * V\z))
EndMacro

Macro PRODUIT_SCALAIRE(V1, V2)
  (V1\x * V2\x + V1\y * V2\y + V1\z * V2\z) 
EndMacro

Macro PRODUIT_VECTORIEL(N, V1, V2)
  N\x = ((V1\y * V2\z) - (V1\z * V2\y))
  N\y = ((V1\z * V2\x) - (V1\x * V2\z))
  N\z = ((V1\x * V2\y) - (V1\y * V2\x))
EndMacro

Global Dim MatriceCamera.f(2, 2)
Global Plan.s_Plan
Global Souris.s_Souris

;Calcul le plan 
Plan\Normale\x = 0
Plan\Normale\y = 1
Plan\Normale\z = 0
Plan\Constante = -(Plan\Normale\x * -5000 + Plan\Normale\y * -1 + Plan\Normale\z * -5000)

Declare CalculMatriceCamera()
; IDE Options = PureBasic 4.10 Beta 3 (Windows - x86)
; CursorPosition = 3
; Folding = --