XIncludeFile "Windows.pbi"
Procedure CreateGadget()
If CreateGadgetList(WindowID(0))
    Frame3DGadget(#FrameBloc       ,815, 10,200,265,"Blocs")
    OptionGadget(#OptionSol        ,820, 30,190, 20,"Sol")
    OptionGadget(#OptionSolOrange  ,820, 50,190, 20,"Sol fragile")
    OptionGadget(#OptionPontGauche ,820, 70,190, 20,"Pont Gauche")
    OptionGadget(#OptionPontDroit  ,820, 90,190, 20,"Pont Droit")
    OptionGadget(#OptionPontHaut   ,820,110,190, 20,"Pont Haut")
    OptionGadget(#OptionPontBas    ,820,130,190, 20,"Pont Bas")
    OptionGadget(#OptionInterSouple,820,150,190, 20,"Switch Souple")
    OptionGadget(#OptionInterDur   ,820,170,190, 20,"Switch Dur")
    OptionGadget(#OptionInterDouble,820,190,190, 20,"Switch Tlporte")
    OptionGadget(#OptionSortie     ,820,210,190, 20,"Sortie")
    OptionGadget(#OptionPlayer     ,820,230,190, 20,"Player")
    OptionGadget(#OptionRien       ,820,250,190, 20,"Aucun")
    Frame3DGadget(#FrameEtat       ,815,280,200, 65,"Etat")
    OptionGadget(#OptionClose      ,820,300,190, 20,"Close")
    OptionGadget(#OptionOpen       ,820,320,190, 20,"Open")
    Frame3DGadget(#FrameEvent      ,815,350,200,255,"Event")
    TreeGadget(#TreeEvent          ,820,370,190,230)
    hCont = ContainerGadget(#Container,5,10,#ScreenW+1,#ScreenH+1)
    OpenWindowedScreen(hCont, 1, 1, #ScreenW, #ScreenH, 0, 0, 0)
    SetGadgetState(#OptionSol  , 1)
    SetGadgetState(#OptionClose, 1)
  EndIf 
  If CreateStatusBar(0,WindowID(0))
    AddStatusBarField(120)
    AddStatusBarField(120)
    AddStatusBarField(120)
    AddStatusBarField(120)
    AddStatusBarField(120)
  EndIf

  If CreateMenu(0,WindowID(0))
    MenuTitle("Fichier")
    MenuItem(#MnuNouveau    , "Nouveau")
    MenuItem(#MnuOuvrir     , "Ouvrir")
    MenuItem(#MnuEnregistrer, "Enregistrer")
    MenuItem(#MnuQuitter    , "Quitter")
  EndIf
  
  If CreatePopupMenu(1)       
  MenuTitle("Ajout vnement")      
    MenuItem(#MnuOpen     , "Open")
    MenuItem(#MnuClose    , "Close")
    MenuItem(#MnuToggle   , "Toggle")
    MenuItem(#MnuTeleporte, "Tlporte")
    CloseSubMenu()
  EndIf
EndProcedure  
Procedure UpdateStatusBar(*Map.s_Map)
  StatusBarText(0, 0, "Map = " + Str(*Map\Level),#PB_StatusBar_Center)
  If IndexArrayOk(*Map,*Map\Bloc\x,*Map\Bloc\z)
    StatusBarText(0, 1, "X = " + Str(*Map\Bloc\x) + " : Z = " + Str(*Map\Bloc\z),#PB_StatusBar_Center)
    StatusBarText(0, 2, "Type = " + TypeBloc(DataMap(*Map\Bloc\x,*Map\Bloc\z)\Type), #PB_StatusBar_Center)
    StatusBarText(0, 3, "Etat = " + Etat(DataMap(*Map\Bloc\x,*Map\Bloc\z)\Etat), #PB_StatusBar_Center) 
    StatusBarText(0, 4, "Event = " + Str(Event(*Map\Bloc\x,*Map\Bloc\z)\NbEvent), #PB_StatusBar_Center)
  EndIf
EndProcedure    
Procedure InitNouveau(*Map.s_Map)
    Define i,j
    CameraLocate(#Camera, Camera\Pos\x, Camera\Pos\y, Camera\Pos\z)
    CameraLookAt(#Camera, Camera\LookAt\x, Camera\LookAt\y, Camera\LookAt\z)
    *Map\Type=#Rien
    *Map\Etat=#Close
    InitEvent(*Map)
    ;Voir pour utiliser InitMap() et ajouter le player  part
    For j=1 To #MaxMapZ
      For i=1 To #MaxMapX
        *Map\Bloc\x=i
        *Map\Bloc\z=j
        InitBloc(*Map) 
      Next i
    Next j 
    *Map\SizeX=#MaxMapX
    *Map\SizeZ=#MaxMapZ  
    *Map\Bloc\x=1
    *Map\Bloc\z=1          
EndProcedure

Procedure HandleMenu(*Map.s_Map, *Player.s_Player)
  Define i,j, Quit
  Select EventMenu()
    Case #MnuNouveau
      InitNouveau(*Map)
      UpdateTree(*Map)  
      InitPlayer(*Player) 
    Case #MnuOuvrir
      InitEvent(*Map)
      InitMap(*Map,*Player)
      OuvreMAp(*Map)       
      LoadMap(*Map, *Player)   
      For j=1 To *Map\SizeZ
        For i=1 To *Map\SizeX
          AddBloc(*Map, *Player,i,j)
        Next i
      Next j  
      InitPlayer(*Player)
      LoadEvent(*Map)
      UpdateTree(*Map)
      ;Change la taille de la map pour dessiner aux limites (elle sera enregistre avec la bonne taille automatiquement)
      *Map\SizeX=#MaxMapX
      *Map\SizeZ=#MaxMapZ  
      
    Case #MnuEnregistrer
      EnregistreMap(*Map,*Player)  
      EnregistreEvent(*Map)
    Case #MnuQuitter
      Quit=#True

    ;-PopupMenu
    Case #MnuClose
      If ControleEvent(*Map)
        UpdateEvent(*Map,#Close)            
        UpdateTree(*Map)
      EndIf  
    Case #MnuOpen
      If ControleEvent(*Map)
        UpdateEvent(*Map,#Open)            
        UpdateTree(*Map)
      EndIf
    Case #MnuToggle
      If ControleEvent(*Map)
        UpdateEvent(*Map,#Toggle)            
        UpdateTree(*Map)
      EndIf  
    Case #MnuTeleporte
      If ControleEvent(*Map)
        UpdateEvent(*Map,#Teleporte)            
        UpdateTree(*Map)            
      EndIf 
  EndSelect
  ProcedureReturn Quit
EndProcedure    
Procedure HandleGadget(*Map.s_Map) 
  Define.l Element, i, j, k, n
  Define.s Texte

  Select EventGadget()
    Case #OptionRien To #OptionPontBas
      ;Neutralise les slections bloc et switch
      *Map\SBloc\x=-1
      *Map\SBloc\z=-1            
      *Map\SSwitch\x=-1
      *Map\SSwitch\z=-1 
    
    Case #TreeEvent
      
      Select EventType()
        Case #PB_EventType_LeftClick    
          If GetKeyState_(#VK_DELETE) & $80
            Element = GetGadgetState(#TreeEvent)
            Texte = GetGadgetItemText(#TreeEvent, Element, 0)
            n=Val(Right(Trim(Texte),3)) ; Coordonnes du switch
            i=n%15                      ; "" 
            j=n/15                      ; ""
            If Left(Trim(Texte),6)="SWITCH" ; Supprime tous les vnements du SWITCH
              k=#PB_Any
            Else
              k=Val(Left(Trim(Texte),2))  ; No de l'vnement  supprimer
            EndIf
            DeleteEvent(i+1,j+1,k)
            UpdateTree(*Map)
         EndIf

      EndSelect               
  EndSelect 
EndProcedure  
Procedure HandleRButtonDown(*Map.s_Map)
  If IndexArrayOk(*Map,*Map\SSwitch\x,*Map\SSwitch\z) And IndexArrayOk(*Map,*Map\SBloc\x,*Map\SBloc\z)
    Select DataMap(*Map\SSwitch\x,*Map\SSwitch\z)\Type
      Case #InterSouple,#InterDur
        Select DataMap(*Map\SBloc\x,*Map\SBloc\z)\Type
          Case #PontBas,#PontDroit,#PontGauche,#PontHaut
            DisableMenuItem(1, #MnuClose, 0)
            DisableMenuItem(1, #MnuOpen, 0)
            DisableMenuItem(1, #MnuToggle, 0)
            DisableMenuItem(1, #MnuTeleporte, 1) 
          Default
            DisableMenuItem(1, #MnuClose, 1)
            DisableMenuItem(1, #MnuOpen, 1)
            DisableMenuItem(1, #MnuToggle, 1)
            DisableMenuItem(1, #MnuTeleporte, 1)   
            MessageRequester("Erreur", "Ce type de bloc (" + Str(*Map\SBloc\x)+"/"+Str(*Map\SBloc\z) +") ne peut pas tre affect  un vnement",0)
        EndSelect

      Case #InterDouble
        DisableMenuItem(1, #MnuClose, 1)
        DisableMenuItem(1, #MnuOpen, 1)
        DisableMenuItem(1, #MnuToggle, 1)
        DisableMenuItem(1, #MnuTeleporte, 0)
      Default
        DisableMenuItem(1, #MnuClose, 1)
        DisableMenuItem(1, #MnuOpen, 1)
        DisableMenuItem(1, #MnuToggle, 1)
        DisableMenuItem(1, #MnuTeleporte, 1)            
    EndSelect
  Else
    DisableMenuItem(1, #MnuClose, 1)
    DisableMenuItem(1, #MnuOpen, 1)
    DisableMenuItem(1, #MnuToggle, 1)
    DisableMenuItem(1, #MnuTeleporte, 1)   
  EndIf                    
       
  DisplayPopupMenu(1,WindowID(0))
EndProcedure        
               
Procedure HandleLButton(*Map.s_Map, *Player.s_Player)
  If GetKeyState_(#VK_LBUTTON) & $80
    ;Si un Switch est slectionn , on le montre et on dvalide le type en cours
    If GetKeyState_(#VK_SHIFT) & $80
      If IndexArrayOk(*Map,*Map\Bloc\x,*Map\Bloc\z)
        Select DataMap(*Map\Bloc\x,*Map\Bloc\z)\Type
          Case #InterSouple,#InterDur,#InterDouble
            *Map\SSwitch\x=*Map\Bloc\x
            *Map\SSwitch\z=*Map\Bloc\z
          Default
             MessageRequester("Erreur", "Ce type de bloc ne supporte pas les vnements",0) 
        EndSelect     
      EndIf  
      
    ;Si un bloc est slectionn , on le montre et on dvalide le type en cours
    ElseIf GetKeyState_(#VK_CONTROL) & $80
      If IndexArrayOk(*Map,*Map\Bloc\x,*Map\Bloc\z)
        *Map\SBloc\x=*Map\Bloc\x
        *Map\SBloc\z=*Map\Bloc\z
      EndIf  
    ;Ajoute des blocs
    Else
      If IndexArrayOk(*Map,*Map\Bloc\x,*Map\Bloc\z)
        ;Neutralise les slections bloc et switch
        *Map\SBloc\x=-1
        *Map\SBloc\z=-1            
        *Map\SSwitch\x=-1
        *Map\SSwitch\z=-1 
        
        ;Ajoute le bloc en cours
        *Map\Etat=#Close
        *Map\Type=-1
        For i=#OptionRien To #OptionPontBas
          If GetGadgetState(i)
            *Map\Type=i-#OptionRien
            Break
          EndIf
        Next i   
        If *Map\Type>-1
          Select *Map\Type
            ;Toutes les cases sont fermes, sauf les ponts qui peuvent s'ouvrir
            Case #PontBas,#PontDroit,#PontGauche,#PontHaut
              If GetGadgetState(#OptionOpen) 
                *Map\Etat=#Open
              EndIf
          EndSelect
  
          InitBloc(*Map)
          AddBloc(*Map,*Player,*Map\Bloc\x,*Map\Bloc\z)
        ElseIf GetGadgetState(#OptionPlayer)
          *Player\Origine\x=*Map\Bloc\x 
          *Player\Origine\z=*Map\Bloc\z 
          *Player\p\x=*Player\Origine\X*#Taille
          *Player\p\y=0
          *Player\p\z=*Player\Origine\Z*#Taille
          EntityLocate(*Player\Entity,*Player\p\x,*Player\p\y,*Player\p\z)
        EndIf  
      EndIf
    EndIf
  EndIf
EndProcedure  
Procedure UpdateTree(*Map.s_Map)
  Define.l i,j,k ,Pos
  Define.s_Event *Ptr
  i=*Map\Bloc\x
  j=*Map\Bloc\z
  ClearGadgetItemList(#TreeEvent)
  For j=1 To #MaxMapZ
    For i=1 To #MaxMapX
      If Event(i,j)\NbEvent 
       
        AddGadgetItem (#TreeEvent, -1, "SWITCH x=" + Str(i) + " : z=" + Str(j) + " - " + RSet(Str(NO_BLOC(i,j)),3,"0"), 0, 0)
        *Ptr=Event(i,j)\Event
        For k=1 To Event(i,j)\NbEvent
          Select *PTr\Type
            Case #Open
              AddGadgetItem (#TreeEvent, -1, RSet(Str(k),2,"0") + "- Open x=" + Str(*Ptr\Bloc\x) + " : z="+ Str(*Ptr\Bloc\z)+ " - "+RSet(Str(NO_BLOC(i,j)),3,"0"), 0, 1)
            Case #Close
              AddGadgetItem (#TreeEvent, -1, RSet(Str(k),2,"0") + "- Close x=" + Str(*Ptr\Bloc\x) + " : z="+ Str(*Ptr\Bloc\z)+ " - "+RSet(Str(NO_BLOC(i,j)),3,"0"), 0, 1)
            Case #Toggle
              AddGadgetItem (#TreeEvent, -1, RSet(Str(k),2,"0") + "- Toggle x=" + Str(*Ptr\Bloc\x) + " : z="+ Str(*Ptr\Bloc\z)+ " - "+RSet(Str(NO_BLOC(i,j)),3,"0"), 0, 1)
            Case #Teleporte
              AddGadgetItem (#TreeEvent, -1, RSet(Str(k),2,"0") + "- Tlporte x=" + Str(*Ptr\Bloc\x) + " : z="+ Str(*Ptr\Bloc\z)+ " - "+RSet(Str(NO_BLOC(i,j)),3,"0"), 0, 1)
          EndSelect
          *Ptr=*Ptr\Next
        Next k
      EndIf
    Next i
  Next j    
EndProcedure
Procedure DeleteEvent(i,j,k)
  Define p 
  Define.s_Event *Ptr, *Precedent
  If Event(i,j)\NbEvent=0
    ProcedureReturn #False
  EndIf  
  *Ptr=Event(i,j)\Event
  If k=#PB_Any
    For p=1 To Event(i,j)\NbEvent
      If *Ptr
        FreeMemory(*Ptr)
      EndIf
      *Ptr=*Ptr\Next
    Next p
    Event(i,j)\NbEvent=0
  Else
    If k=1
      Event(i,j)\Event=*Ptr\Next
      FreeMemory(*Ptr)
    Else
      For p = 1 To k
        If p=k
          *Precedent\Next=*Ptr\Next
          FreeMemory(*Ptr)
          Break
        Else  
          *Precedent=*Ptr
          *Ptr=*Ptr\Next
        EndIf
      Next p
    EndIf 
    Event(i,j)\NbEvent - 1
  EndIf 
 
EndProcedure
Procedure AddEvent(*Map.s_Map,i,j)
  Define k
  Define.s_Event *Ptr
  If Event(i,j)\Event=0
    Event(i,j)\Event=AllocateMemory(SizeOf(s_Event))
    *Ptr=Event(i,j)\Event
  Else  
    *Ptr=Event(i,j)\Event
    While *Ptr\Next
      *Ptr=*Ptr\Next
    Wend
    *Ptr\Next=AllocateMemory(SizeOf(s_Event))
    *Ptr=*Ptr\Next
  EndIf
  *Ptr\Next=#Null
  Event(i,j)\NbEvent + 1
  ProcedureReturn *Ptr
EndProcedure
Procedure UpdateEvent(*Map.s_Map,Type)  
  Define i,j,k
  Define.s_Event *Ptr
  *Ptr=AddEvent(*Map,*Map\SSwitch\x,*Map\SSwitch\z)
  *Ptr\Type=Type
  *Ptr\Bloc\x=*Map\SBloc\x
  *Ptr\Bloc\z=*Map\SBloc\z
EndProcedure
Procedure ControleEvent(*Map.s_Map)
  Define k
  Define.s_Event *Ptr
  *Ptr=Event(*Map\SSwitch\x,*Map\SSwitch\z)\Event
  For k=1 To Event(*Map\SSwitch\x,*Map\SSwitch\z)\NbEvent
    If *Ptr\Bloc\x=*Map\SBloc\x And *Ptr\Bloc\z=*Map\SBloc\z  
      MessageRequester("Erreur","Un vnement existe dj pour ce bloc",0)
      ProcedureReturn #False
    EndIf 
    *Ptr=*Ptr\Next 
  Next k  
  ProcedureReturn #True ; Il n'y a pas de doublon ,cet vnement peut tre ajout  la liste
EndProcedure


; IDE Options = PureBasic 4.10 Beta 3 (Windows - x86)
; CursorPosition = 243
; FirstLine = 208
; Folding = ---